/* ***********************************************************
 * This file was automatically generated on 2019-09-16.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;

/**
 * Two tactile buttons with built-in blue LEDs
 */
public class BrickletDualButton extends Device {
	public final static int DEVICE_IDENTIFIER = 230;
	public final static String DEVICE_DISPLAY_NAME = "Dual Button Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "dualbutton", DEVICE_IDENTIFIER, BrickletDualButton.class);

	public final static byte FUNCTION_SET_LED_STATE = (byte)1;
	public final static byte FUNCTION_GET_LED_STATE = (byte)2;
	public final static byte FUNCTION_GET_BUTTON_STATE = (byte)3;
	public final static byte FUNCTION_SET_SELECTED_LED_STATE = (byte)5;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_STATE_CHANGED = 4;

	public final static short LED_STATE_AUTO_TOGGLE_ON = (short)0;
	public final static short LED_STATE_AUTO_TOGGLE_OFF = (short)1;
	public final static short LED_STATE_ON = (short)2;
	public final static short LED_STATE_OFF = (short)3;
	public final static short BUTTON_STATE_PRESSED = (short)0;
	public final static short BUTTON_STATE_RELEASED = (short)1;
	public final static short LED_LEFT = (short)0;
	public final static short LED_RIGHT = (short)1;

	private List<StateChangedListener> listenerStateChanged = new CopyOnWriteArrayList<StateChangedListener>();

	public class LEDState {
		public short ledL;
		public short ledR;

		public String toString() {
			return "[" + "ledL = " + ledL + ", " + "ledR = " + ledR + "]";
		}
	}

	public class ButtonState {
		public short buttonL;
		public short buttonR;

		public String toString() {
			return "[" + "buttonL = " + buttonL + ", " + "buttonR = " + buttonR + "]";
		}
	}

	/**
	 * This listener is called whenever a button is pressed.
	 * 
	 * Possible states for buttons are:
	 * 
	 * * 0 = pressed
	 * * 1 = released
	 * 
	 * Possible states for LEDs are:
	 * 
	 * * 0 = AutoToggleOn: Auto toggle enabled and LED on.
	 * * 1 = AutoToggleOff: Auto toggle enabled and LED off.
	 * * 2 = On: LED on (auto toggle is disabled).
	 * * 3 = Off: LED off (auto toggle is disabled).
	 */
	public interface StateChangedListener extends DeviceListener {
		public void stateChanged(short buttonL, short buttonR, short ledL, short ledR);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletDualButton(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_LED_STATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_LED_STATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BUTTON_STATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_LED_STATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_STATE_CHANGED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short buttonL = IPConnection.unsignedByte(bb.get());
				short buttonR = IPConnection.unsignedByte(bb.get());
				short ledL = IPConnection.unsignedByte(bb.get());
				short ledR = IPConnection.unsignedByte(bb.get());

				for (StateChangedListener listener: listenerStateChanged) {
					listener.stateChanged(buttonL, buttonR, ledL, ledR);
				}
			}
		};
	}

	/**
	 * Sets the state of the LEDs. Possible states are:
	 * 
	 * * 0 = AutoToggleOn: Enables auto toggle with initially enabled LED.
	 * * 1 = AutoToggleOff: Activates auto toggle with initially disabled LED.
	 * * 2 = On: Enables LED (auto toggle is disabled).
	 * * 3 = Off: Disables LED (auto toggle is disabled).
	 * 
	 * In auto toggle mode the LED is toggled automatically at each press of a button.
	 * 
	 * If you just want to set one of the LEDs and don't know the current state
	 * of the other LED, you can get the state with {@link BrickletDualButton#getLEDState()} or you
	 * can use {@link BrickletDualButton#setSelectedLEDState(short, short)}.
	 * 
	 * The default value is (1, 1).
	 */
	public void setLEDState(short ledL, short ledR) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_LED_STATE, this);

		bb.put((byte)ledL);
		bb.put((byte)ledR);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current state of the LEDs, as set by {@link BrickletDualButton#setLEDState(short, short)}.
	 */
	public LEDState getLEDState() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_LED_STATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		LEDState obj = new LEDState();
		obj.ledL = IPConnection.unsignedByte(bb.get());
		obj.ledR = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the current state for both buttons. Possible states are:
	 * 
	 * * 0 = pressed
	 * * 1 = released
	 */
	public ButtonState getButtonState() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BUTTON_STATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ButtonState obj = new ButtonState();
		obj.buttonL = IPConnection.unsignedByte(bb.get());
		obj.buttonR = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets the state of the selected LED (0 or 1).
	 * 
	 * The other LED remains untouched.
	 */
	public void setSelectedLEDState(short led, short state) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_LED_STATE, this);

		bb.put((byte)led);
		bb.put((byte)state);

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a StateChanged listener.
	 */
	public void addStateChangedListener(StateChangedListener listener) {
		listenerStateChanged.add(listener);
	}

	/**
	 * Removes a StateChanged listener.
	 */
	public void removeStateChangedListener(StateChangedListener listener) {
		listenerStateChanged.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletDualButton.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDualButton.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        this.addStateChangedListener((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("DualButtonLeftButton", transformDualButtonLeftButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}});
		this.addStateChangedListener((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("DualButtonRightButton", transformDualButtonRightButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}});
        this.setLEDState(cfg.leftLEDState.shortValue(), cfg.rightLEDState.shortValue());
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        this.listenerStateChanged.clear();
		this.listenerStateChanged.clear();
        
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("DualButtonLeftButton");
		result.add("DualButtonRightButton");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Dual Button Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Two tactile buttons with built-in blue LEDs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("DualButtonLeftButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Left Button").build(), new ChannelDefinitionBuilder("DualButtonRightButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Right Button").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:dualbutton":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("leftLEDState", Type.INTEGER).withDefault("0").withDescription("Left LED State").withLabel("Left LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle On"), new ParameterOption("1", "Auto Toggle Off"), new ParameterOption("2", "On"), new ParameterOption("3", "Off"))).build(), ConfigDescriptionParameterBuilder.create("rightLEDState", Type.INTEGER).withDefault("0").withDescription("Right LED State").withLabel("Right LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle On"), new ParameterOption("1", "Auto Toggle Off"), new ParameterOption("2", "On"), new ParameterOption("3", "Off"))).build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        switch(value) {
            case "DualButtonLeftButton":
                   triggerChannelFn.accept(value, transformDualButtonLeftButtonGetter0(this.getButtonState(), cfg));
                   return;
            case "DualButtonRightButton":
                   triggerChannelFn.accept(value, transformDualButtonRightButtonGetter0(this.getButtonState(), cfg));
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformDualButtonLeftButtonCallback0(short buttonL, short buttonR, short ledL, short ledR, BrickletDualButtonConfig cfg) {
        return buttonL == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformDualButtonRightButtonCallback0(short buttonL, short buttonR, short ledL, short ledR, BrickletDualButtonConfig cfg) {
        return buttonR == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformDualButtonLeftButtonGetter0(ButtonState value, BrickletDualButtonConfig cfg) {
        return value.buttonL == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformDualButtonRightButtonGetter0(ButtonState value, BrickletDualButtonConfig cfg) {
        return value.buttonR == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
}
