/* ***********************************************************
 * This file was automatically generated on 2019-09-16.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated digital outputs
 */
public class BrickletIndustrialDigitalOut4 extends Device {
	public final static int DEVICE_IDENTIFIER = 224;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Digital Out 4 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "industrialdigitalout4", DEVICE_IDENTIFIER, BrickletIndustrialDigitalOut4.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)3;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)4;
	public final static byte FUNCTION_SET_GROUP = (byte)5;
	public final static byte FUNCTION_GET_GROUP = (byte)6;
	public final static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = (byte)7;
	public final static byte FUNCTION_SET_SELECTED_VALUES = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MONOFLOP_DONE = 8;


	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Monoflop {
		public int value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the involved pins and the current value of the pins
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int selectionMask, int valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialDigitalOut4(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_GROUP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AVAILABLE_FOR_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUES)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int selectionMask = IPConnection.unsignedShort(bb.getShort());
				int valueMask = IPConnection.unsignedShort(bb.getShort());

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(selectionMask, valueMask);
				}
			}
		};
	}

	/**
	 * Sets the output value with a bitmask (16bit). A 1 in the bitmask means high
	 * and a 0 in the bitmask means low.
	 * 
	 * For example: The value 3 or 0b0011 will turn pins 0-1 high and the other pins
	 * low.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialDigitalOut4#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Digital Out 4 Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 */
	public void setValue(int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VALUE, this);

		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the bitmask as set by {@link BrickletIndustrialDigitalOut4#setValue(int)}.
	 */
	public int getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int valueMask = IPConnection.unsignedShort(bb.getShort());

		return valueMask;
	}

	/**
	 * Configures a monoflop of the pins specified by the first parameter
	 * bitmask.
	 * 
	 * The second parameter is a bitmask with the desired value of the specified
	 * pins. A 1 in the bitmask means high and a 0 in the bitmask means low.
	 * 
	 * The third parameter indicates the time (in ms) that the pins should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (9, 1, 1500) or
	 * (0b1001, 0b0001, 1500): Pin 0 will get high and pin 3 will get low. In 1.5s
	 * pin 0 will get low and pin 3 will get high again.
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and a Digital Out 4 Bricklet connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds and pin 0 high. Pin 0 will be high all the time. If now
	 * the RS485 connection is lost, then pin 0 will turn low in at most two seconds.
	 */
	public void setMonoflop(int selectionMask, int valueMask, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_MONOFLOP, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given pin) the current value and the time as set by
	 * {@link BrickletIndustrialDigitalOut4#setMonoflop(int, int, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = IPConnection.unsignedShort(bb.getShort());
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets a group of Digital Out 4 Bricklets that should work together. You can
	 * find Bricklets that can be grouped together with {@link BrickletIndustrialDigitalOut4#getAvailableForGroup()}.
	 * 
	 * The group consists of 4 elements. Element 1 in the group will get pins 0-3,
	 * element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
	 * 
	 * Each element can either be one of the ports ('a' to 'd') or 'n' if it should
	 * not be used.
	 * 
	 * For example: If you have two Digital Out 4 Bricklets connected to port A and
	 * port B respectively, you could call with ``['a', 'b', 'n', 'n']``.
	 * 
	 * Now the pins on the Digital Out 4 on port A are assigned to 0-3 and the
	 * pins on the Digital Out 4 on port B are assigned to 4-7. It is now possible
	 * to call {@link BrickletIndustrialDigitalOut4#setValue(int)} and control two Bricklets at the same time.
	 */
	public void setGroup(char[] group) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_GROUP, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)group[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the group as set by {@link BrickletIndustrialDigitalOut4#setGroup(char[])}
	 */
	public char[] getGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		char[] group = new char[4];
		for (int i = 0; i < 4; i++) {
			group[i] = (char)(bb.get());
		}

		return group;
	}

	/**
	 * Returns a bitmask of ports that are available for grouping. For example the
	 * value 5 or 0b0101 means: Port A and port C are connected to Bricklets that
	 * can be grouped together.
	 */
	public short getAvailableForGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AVAILABLE_FOR_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short available = IPConnection.unsignedByte(bb.get());

		return available;
	}

	/**
	 * Sets the output value with a bitmask, according to the selection mask.
	 * The bitmask is 16 bit long, *true* refers to high and *false* refers to
	 * low.
	 * 
	 * For example: The values (3, 1) or (0b0011, 0b0001) will turn pin 0 high, pin 1
	 * low the other pins remain untouched.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialDigitalOut4#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Digital Out 4 Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * Running monoflop timers for the selected pins will be aborted if this function
	 * is called.
	 */
	public void setSelectedValues(int selectionMask, int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SELECTED_VALUES, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDigitalOut4.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDigitalOut4.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4Config cfg = (BrickletIndustrialDigitalOut4Config) config.as(BrickletIndustrialDigitalOut4Config.class);
        this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) > 0) {updateStateFn.accept("IndustrialDigitalOut4OutputPin0", transformIndustrialDigitalOut4OutputPin0Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) > 0) {updateStateFn.accept("IndustrialDigitalOut4OutputPin1", transformIndustrialDigitalOut4OutputPin1Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) > 0) {updateStateFn.accept("IndustrialDigitalOut4OutputPin2", transformIndustrialDigitalOut4OutputPin2Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) > 0) {updateStateFn.accept("IndustrialDigitalOut4OutputPin3", transformIndustrialDigitalOut4OutputPin3Callback0(selectionMask, valueMask, cfg));}});
        
		{
		BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4OutputPin0").as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4OutputPin1").as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4OutputPin2").as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4OutputPin3").as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4MonoflopPin0").as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4MonoflopPin1").as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4MonoflopPin2").as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalOut4MonoflopPin3").as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4Config cfg = (BrickletIndustrialDigitalOut4Config) config.as(BrickletIndustrialDigitalOut4Config.class);
        this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDigitalOut4Config cfg = (BrickletIndustrialDigitalOut4Config) config.as(BrickletIndustrialDigitalOut4Config.class);
        List<String> result = new ArrayList<String>();
        result.add("IndustrialDigitalOut4OutputPin0");
		result.add("IndustrialDigitalOut4OutputPin1");
		result.add("IndustrialDigitalOut4OutputPin2");
		result.add("IndustrialDigitalOut4OutputPin3");
		result.add("IndustrialDigitalOut4MonoflopPin0");
		result.add("IndustrialDigitalOut4MonoflopPin1");
		result.add("IndustrialDigitalOut4MonoflopPin2");
		result.add("IndustrialDigitalOut4MonoflopPin3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IndustrialDigitalOut4OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialDigitalOut4OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IndustrialDigitalOut4Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialDigitalOut4Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Digital Out 4 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated digital outputs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IndustrialDigitalOut4OutputPin0", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4OutputPin")).withLabel("Output Value (Pin 0)").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4OutputPin1", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4OutputPin")).withLabel("Output Value (Pin 1)").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4OutputPin2", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4OutputPin")).withLabel("Output Value (Pin 2)").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4OutputPin3", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4OutputPin")).withLabel("Output Value (Pin 3)").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4MonoflopPin0", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4MonoflopPin1", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4MonoflopPin2", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("IndustrialDigitalOut4MonoflopPin3", new ChannelTypeUID("tinkerforge", "IndustrialDigitalOut4Monoflop")).withLabel("Monoflop Pin 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:industrialdigitalout4":
                return new ConfigDescription(uri, Arrays.asList());
            case "channel-type:tinkerforge:IndustrialDigitalOut4OutputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IndustrialDigitalOut4Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalOut4Config cfg = (BrickletIndustrialDigitalOut4Config) config.as(BrickletIndustrialDigitalOut4Config.class);
        switch(value) {
            case "IndustrialDigitalOut4OutputPin0": {
                   BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4OutputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalOut4OutputPin1": {
                   BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4OutputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalOut4OutputPin2": {
                   BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4OutputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalOut4OutputPin3": {
                   BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4OutputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalOut4MonoflopPin0": {
                   BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4MonoflopPin0Getter0(this.getMonoflop((short)0), cfg));
                   return;
               }
            case "IndustrialDigitalOut4MonoflopPin1": {
                   BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4MonoflopPin1Getter0(this.getMonoflop((short)1), cfg));
                   return;
               }
            case "IndustrialDigitalOut4MonoflopPin2": {
                   BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4MonoflopPin2Getter0(this.getMonoflop((short)2), cfg));
                   return;
               }
            case "IndustrialDigitalOut4MonoflopPin3": {
                   BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalOut4MonoflopPin3Getter0(this.getMonoflop((short)3), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialDigitalOut4Config cfg = (BrickletIndustrialDigitalOut4Config) config.as(BrickletIndustrialDigitalOut4Config.class);
        switch(channel) {
            case "IndustrialDigitalOut4OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDigitalOut4OutputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IndustrialDigitalOut4OutputPin0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IndustrialDigitalOut4OutputPin1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IndustrialDigitalOut4OutputPin2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialDigitalOut4MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIndustrialDigitalOut4MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalOut4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IndustrialDigitalOut4OutputPin3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin0Callback0(int selectionMask, int valueMask, BrickletIndustrialDigitalOut4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin1Callback0(int selectionMask, int valueMask, BrickletIndustrialDigitalOut4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin2Callback0(int selectionMask, int valueMask, BrickletIndustrialDigitalOut4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin3Callback0(int selectionMask, int valueMask, BrickletIndustrialDigitalOut4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin0Getter0(int value, BrickletIndustrialDigitalOut4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin1Getter0(int value, BrickletIndustrialDigitalOut4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin2Getter0(int value, BrickletIndustrialDigitalOut4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4OutputPin3Getter0(int value, BrickletIndustrialDigitalOut4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4MonoflopPin0Getter0(Monoflop value, BrickletIndustrialDigitalOut4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4MonoflopPin1Getter0(Monoflop value, BrickletIndustrialDigitalOut4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4MonoflopPin2Getter0(Monoflop value, BrickletIndustrialDigitalOut4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalOut4MonoflopPin3Getter0(Monoflop value, BrickletIndustrialDigitalOut4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
}
