/* ***********************************************************
 * This file was automatically generated on 2019-09-16.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import java.time.ZonedDateTime;
import java.time.ZoneId;
import org.eclipse.smarthome.core.library.types.DateTimeType;

/**
 * Battery-backed real-time clock
 */
public class BrickletRealTimeClockV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2106;
	public final static String DEVICE_DISPLAY_NAME = "Real-Time Clock Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "realtimeclockv2", DEVICE_IDENTIFIER, BrickletRealTimeClockV2.class);

	public final static byte FUNCTION_SET_DATE_TIME = (byte)1;
	public final static byte FUNCTION_GET_DATE_TIME = (byte)2;
	public final static byte FUNCTION_GET_TIMESTAMP = (byte)3;
	public final static byte FUNCTION_SET_OFFSET = (byte)4;
	public final static byte FUNCTION_GET_OFFSET = (byte)5;
	public final static byte FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_ALARM = (byte)8;
	public final static byte FUNCTION_GET_ALARM = (byte)9;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_DATE_TIME = 10;
	private final static int CALLBACK_ALARM = 11;

	public final static int WEEKDAY_MONDAY = 1;
	public final static int WEEKDAY_TUESDAY = 2;
	public final static int WEEKDAY_WEDNESDAY = 3;
	public final static int WEEKDAY_THURSDAY = 4;
	public final static int WEEKDAY_FRIDAY = 5;
	public final static int WEEKDAY_SATURDAY = 6;
	public final static int WEEKDAY_SUNDAY = 7;
	public final static int ALARM_MATCH_DISABLED = -1;
	public final static int ALARM_INTERVAL_DISABLED = -1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<DateTimeListener> listenerDateTime = new CopyOnWriteArrayList<DateTimeListener>();
	private List<AlarmListener> listenerAlarm = new CopyOnWriteArrayList<AlarmListener>();

	public class DateTime {
		public int year;
		public int month;
		public int day;
		public int hour;
		public int minute;
		public int second;
		public int centisecond;
		public int weekday;
		public long timestamp;

		public String toString() {
			return "[" + "year = " + year + ", " + "month = " + month + ", " + "day = " + day + ", " + "hour = " + hour + ", " + "minute = " + minute + ", " + "second = " + second + ", " + "centisecond = " + centisecond + ", " + "weekday = " + weekday + ", " + "timestamp = " + timestamp + "]";
		}
	}

	public class Alarm {
		public int month;
		public int day;
		public int hour;
		public int minute;
		public int second;
		public int weekday;
		public int interval;

		public String toString() {
			return "[" + "month = " + month + ", " + "day = " + day + ", " + "hour = " + hour + ", " + "minute = " + minute + ", " + "second = " + second + ", " + "weekday = " + weekday + ", " + "interval = " + interval + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletRealTimeClockV2#setDateTimeCallbackConfiguration(long)}. The parameters are the
	 * same as for {@link BrickletRealTimeClockV2#getDateTime()}.
	 */
	public interface DateTimeListener extends DeviceListener {
		public void dateTime(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp);
	}

	/**
	 * This listener is triggered every time the current date and time matches the
	 * configured alarm (see {@link BrickletRealTimeClockV2#setAlarm(int, int, int, int, int, int, int)}). The parameters are the same
	 * as for {@link BrickletRealTimeClockV2#getDateTime()}.
	 */
	public interface AlarmListener extends DeviceListener {
		public void alarm(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRealTimeClockV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DATE_TIME)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TIMESTAMP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_OFFSET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_OFFSET)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALARM)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALARM)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_DATE_TIME] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int year = IPConnection.unsignedShort(bb.getShort());
				int month = IPConnection.unsignedByte(bb.get());
				int day = IPConnection.unsignedByte(bb.get());
				int hour = IPConnection.unsignedByte(bb.get());
				int minute = IPConnection.unsignedByte(bb.get());
				int second = IPConnection.unsignedByte(bb.get());
				int centisecond = IPConnection.unsignedByte(bb.get());
				int weekday = IPConnection.unsignedByte(bb.get());
				long timestamp = (bb.getLong());

				for (DateTimeListener listener: listenerDateTime) {
					listener.dateTime(year, month, day, hour, minute, second, centisecond, weekday, timestamp);
				}
			}
		};

		callbacks[CALLBACK_ALARM] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int year = IPConnection.unsignedShort(bb.getShort());
				int month = IPConnection.unsignedByte(bb.get());
				int day = IPConnection.unsignedByte(bb.get());
				int hour = IPConnection.unsignedByte(bb.get());
				int minute = IPConnection.unsignedByte(bb.get());
				int second = IPConnection.unsignedByte(bb.get());
				int centisecond = IPConnection.unsignedByte(bb.get());
				int weekday = IPConnection.unsignedByte(bb.get());
				long timestamp = (bb.getLong());

				for (AlarmListener listener: listenerAlarm) {
					listener.alarm(year, month, day, hour, minute, second, centisecond, weekday, timestamp);
				}
			}
		};
	}

	/**
	 * Sets the current date (including weekday) and the current time with hundredths
	 * of a second resolution.
	 * 
	 * Possible value ranges:
	 * 
	 * * Year: 2000 to 2099
	 * * Month: 1 to 12 (January to December)
	 * * Day: 1 to 31
	 * * Hour: 0 to 23
	 * * Minute: 0 to 59
	 * * Second: 0 to 59
	 * * Centisecond: 0 to 99
	 * * Weekday: 1 to 7 (Monday to Sunday)
	 * 
	 * If the backup battery is installed then the real-time clock keeps date and
	 * time even if the Bricklet is not powered by a Brick.
	 * 
	 * The real-time clock handles leap year and inserts the 29th of February
	 * accordingly. But leap seconds, time zones and daylight saving time are not
	 * handled.
	 */
	public void setDateTime(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_DATE_TIME, this);

		bb.putShort((short)year);
		bb.put((byte)month);
		bb.put((byte)day);
		bb.put((byte)hour);
		bb.put((byte)minute);
		bb.put((byte)second);
		bb.put((byte)centisecond);
		bb.put((byte)weekday);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current date (including weekday) and the current time of the
	 * real-time clock with hundredths of a second resolution.
	 * 
	 * The timestamp represents the current date and the the current time of the
	 * real-time clock converted to milliseconds.
	 */
	public DateTime getDateTime() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DateTime obj = new DateTime();
		obj.year = IPConnection.unsignedShort(bb.getShort());
		obj.month = IPConnection.unsignedByte(bb.get());
		obj.day = IPConnection.unsignedByte(bb.get());
		obj.hour = IPConnection.unsignedByte(bb.get());
		obj.minute = IPConnection.unsignedByte(bb.get());
		obj.second = IPConnection.unsignedByte(bb.get());
		obj.centisecond = IPConnection.unsignedByte(bb.get());
		obj.weekday = IPConnection.unsignedByte(bb.get());
		obj.timestamp = (bb.getLong());

		return obj;
	}

	/**
	 * Returns the current date and the time of the real-time clock converted to
	 * milliseconds. The timestamp has an effective resolution of hundredths of a
	 * second.
	 */
	public long getTimestamp() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TIMESTAMP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long timestamp = (bb.getLong());

		return timestamp;
	}

	/**
	 * Sets the offset the real-time clock should compensate for in 2.17 ppm steps
	 * between -277.76 ppm (-128) and +275.59 ppm (127).
	 * 
	 * The real-time clock time can deviate from the actual time due to the frequency
	 * deviation of its 32.768 kHz crystal. Even without compensation (factory
	 * default) the resulting time deviation should be at most ±20 ppm (±52.6
	 * seconds per month).
	 * 
	 * This deviation can be calculated by comparing the same duration measured by the
	 * real-time clock (``rtc_duration``) an accurate reference clock
	 * (``ref_duration``).
	 * 
	 * For best results the configured offset should be set to 0 ppm first and then a
	 * duration of at least 6 hours should be measured.
	 * 
	 * The new offset (``new_offset``) can be calculated from the currently configured
	 * offset (``current_offset``) and the measured durations as follow::
	 * 
	 *   new_offset = current_offset - round(1000000 * (rtc_duration - ref_duration) / rtc_duration / 2.17)
	 * 
	 * If you want to calculate the offset, then we recommend using the calibration
	 * dialog in Brick Viewer, instead of doing it manually.
	 * 
	 * The offset is saved in the EEPROM of the Bricklet and only needs to be
	 * configured once.
	 */
	public void setOffset(int offset) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_OFFSET, this);

		bb.put((byte)offset);

		sendRequest(bb.array());
	}

	/**
	 * Returns the offset as set by {@link BrickletRealTimeClockV2#setOffset(int)}.
	 */
	public int getOffset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OFFSET, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int offset = (bb.get());

		return offset;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletRealTimeClockV2.DateTimeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The default value is 0.
	 */
	public void setDateTimeCallbackConfiguration(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DATE_TIME_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletRealTimeClockV2#setDateTimeCallbackConfiguration(long)}.
	 */
	public long getDateTimeCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Configures a repeatable alarm. The {@link BrickletRealTimeClockV2.AlarmListener} listener is triggered if the
	 * current date and time matches the configured alarm.
	 * 
	 * Setting a parameter to -1 means that it should be disabled and doesn't take part
	 * in the match. Setting all parameters to -1 disables the alarm completely.
	 * 
	 * For example, to make the alarm trigger every day at 7:30 AM it can be
	 * configured as (-1, -1, 7, 30, -1, -1, -1). The hour is set to match 7 and the
	 * minute is set to match 30. The alarm is triggered if all enabled parameters
	 * match.
	 * 
	 * The interval has a special role. It allows to make the alarm reconfigure itself.
	 * This is useful if you need a repeated alarm that cannot be expressed by matching
	 * the current date and time. For example, to make the alarm trigger every 23
	 * seconds it can be configured as (-1, -1, -1, -1, -1, -1, 23). Internally the
	 * Bricklet will take the current date and time, add 23 seconds to it and set the
	 * result as its alarm. The first alarm will be triggered 23 seconds after the
	 * call. Because the interval is not -1, the Bricklet will do the same again
	 * internally, take the current date and time, add 23 seconds to it and set that
	 * as its alarm. This results in a repeated alarm that triggers every 23 seconds.
	 * 
	 * The interval can also be used in combination with the other parameters. For
	 * example, configuring the alarm as (-1, -1, 7, 30, -1, -1, 300) results in an
	 * alarm that triggers every day at 7:30 AM and is then repeated every 5 minutes.
	 */
	public void setAlarm(int month, int day, int hour, int minute, int second, int weekday, int interval) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_SET_ALARM, this);

		bb.put((byte)month);
		bb.put((byte)day);
		bb.put((byte)hour);
		bb.put((byte)minute);
		bb.put((byte)second);
		bb.put((byte)weekday);
		bb.putInt(interval);

		sendRequest(bb.array());
	}

	/**
	 * Returns the alarm configuration as set by {@link BrickletRealTimeClockV2#setAlarm(int, int, int, int, int, int, int)}.
	 */
	public Alarm getAlarm() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALARM, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Alarm obj = new Alarm();
		obj.month = (bb.get());
		obj.day = (bb.get());
		obj.hour = (bb.get());
		obj.minute = (bb.get());
		obj.second = (bb.get());
		obj.weekday = (bb.get());
		obj.interval = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletRealTimeClockV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletRealTimeClockV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletRealTimeClockV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletRealTimeClockV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a DateTime listener.
	 */
	public void addDateTimeListener(DateTimeListener listener) {
		listenerDateTime.add(listener);
	}

	/**
	 * Removes a DateTime listener.
	 */
	public void removeDateTimeListener(DateTimeListener listener) {
		listenerDateTime.remove(listener);
	}

	/**
	 * Adds a Alarm listener.
	 */
	public void addAlarmListener(AlarmListener listener) {
		listenerAlarm.add(listener);
	}

	/**
	 * Removes a Alarm listener.
	 */
	public void removeAlarmListener(AlarmListener listener) {
		listenerAlarm.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletRealTimeClockV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRealTimeClockV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        this.addDateTimeListener((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("RealTimeClockV2DateTime", transformRealTimeClockV2DateTimeCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}});
		this.addDateTimeListener((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("RealTimeClockV2Timestamp", transformRealTimeClockV2TimestampCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}});
        this.setDateTimeCallbackConfiguration(cfg.updateInterval);
		{
		BrickletRealTimeClockV2DateTimeConfig channelCfg = getChannelConfigFn.apply("RealTimeClockV2DateTime").as(BrickletRealTimeClockV2DateTimeConfig.class);
		
		}
		{
		BrickletRealTimeClockV2TimestampConfig channelCfg = getChannelConfigFn.apply("RealTimeClockV2Timestamp").as(BrickletRealTimeClockV2TimestampConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        this.listenerDateTime.clear();
		this.listenerDateTime.clear();
        
		
		this.setDateTimeCallbackConfiguration(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("RealTimeClockV2DateTime");
		result.add("RealTimeClockV2Timestamp");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "RealTimeClockV2DateTime":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "RealTimeClockV2DateTime"), "Date Time", "DateTime").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:RealTimeClockV2DateTime")).withDescription("The real-time clock handles leap year and inserts the 29th of February accordingly. But leap seconds are not handled. The time is stored as UTC on the clock and converted into your system's timezone when accessed by OpenHAB.").build();
            case "RealTimeClockV2Timestamp":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "RealTimeClockV2Timestamp"), "Timestamp", "Number:Time").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:RealTimeClockV2Timestamp")).withDescription("the current date and the time of the real-time clock converted to seconds. The timestamp has an effective resolution of hundredths of a second.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Real-Time Clock Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Battery-backed real-time clock").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("RealTimeClockV2DateTime", new ChannelTypeUID("tinkerforge", "RealTimeClockV2DateTime")).withLabel("Date Time").build(), new ChannelDefinitionBuilder("RealTimeClockV2Timestamp", new ChannelTypeUID("tinkerforge", "RealTimeClockV2Timestamp")).withLabel("Timestamp").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:realtimeclockv2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:RealTimeClockV2DateTime":
                return new ConfigDescription(uri, Arrays.asList());
            case "channel-type:tinkerforge:RealTimeClockV2Timestamp":
                return new ConfigDescription(uri, Arrays.asList());
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        switch(value) {
            case "RealTimeClockV2DateTime": {
                   BrickletRealTimeClockV2DateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2DateTimeConfig.class);
                   updateStateFn.accept(value, transformRealTimeClockV2DateTimeGetter0(this.getDateTime(), cfg));
                   return;
               }
            case "RealTimeClockV2Timestamp": {
                   BrickletRealTimeClockV2TimestampConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2TimestampConfig.class);
                   updateStateFn.accept(value, transformRealTimeClockV2TimestampGetter0(this.getTimestamp(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        switch(channel) {
            case "RealTimeClockV2DateTime":
                if (command instanceof DateTimeType) {
                    BrickletRealTimeClockV2DateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2DateTimeConfig.class);
                    DateTimeType cmd = (DateTimeType) command;
                    this.setDateTime(cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getYear(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMonth().getValue(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfMonth(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getHour(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMinute(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getSecond(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getNano() / 1000 / 1000 / 10, cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfWeek().getValue());
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a DateTimeType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformRealTimeClockV2DateTimeCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockV2Config cfg) {
        return new DateTimeType(ZonedDateTime.of(year, month, day, hour, minute, second, centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformRealTimeClockV2TimestampCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockV2Config cfg) {
        return new QuantityType<>(timestamp / 1000.0, SmartHomeUnits.SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformRealTimeClockV2DateTimeGetter0(DateTime value, BrickletRealTimeClockV2Config cfg) {
        return new DateTimeType(ZonedDateTime.of(value.year, value.month, value.day, value.hour, value.minute, value.second, value.centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformRealTimeClockV2TimestampGetter0(long value, BrickletRealTimeClockV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.SECOND);
    }
}
